Unit ZP34R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTZP10_p;

procedure ZP34R(NP :Integer; var A :Array of Real; M :Integer;
                var B :Array of Real; var IERR :Integer);

implementation

procedure ZP34R(NP :Integer; var A :Array of Real; M :Integer;
                var B :Array of Real; var IERR :Integer);
var
I,J,J2,KJ,N :Integer;
X :Extended;
label
_1,_2,_3,_4;
begin
N := NP;
if ( A[0] > 0.0 ) 
 then goto _1;
IERR := 65;
UTZP10(IERR,34);
goto _4;
_1:
B[0] := Ln(A[0]);
if ( NP <= 1 ) 
 then goto _4;
if ( M <= 1 ) 
 then goto _4;
B[1] := A[1]/A[0];
if ( M <= 2 ) 
 then goto _4;
for I:=3 to M do
 begin
  X := 0.e0;
  KJ := I-2;
  if ( KJ > NP ) 
   then KJ := NP;
  for J:=1 to KJ do
   begin
    J2 := I-J;
_2:
    X := X+(I-J-1)*(A[J+0])*(B[J2-1]);
   end;
  B[I-1] := -X/((I-1)*A[0]);
  if ( NP = 2 ) 
   then goto _3;
  if ( I <= NP+1 ) 
   then B[I-1] := B[I-1]+A[I-1]/A[0];
_3:
 end;
_4:
end;

end.
